import java.awt.Point;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class losthouses {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new losthouses().run();
	}
	
	Set<Point> pts = new TreeSet<>(new Comparator<Point>() {
		@Override
		public int compare(Point o1, Point o2) {
			return (o1.x != o2.x) ? Integer.compare(o1.x, o2.x) : Integer.compare(o1.y, o2.y);
		}
	});
	boolean[] used;
	
	void run() {
		int n4 = nextInt() << 2;
		for (int i = 0; i < n4; ++i) pts.add(new Point(nextInt(), nextInt())); 
		long sum = 0;
		while (!pts.isEmpty()) {
			Iterator<Point> it = pts.iterator();
			Point p = it.next(), m2 = null, m3 = null, m4 = null;
			long min2 = Long.MAX_VALUE;
			while (it.hasNext()) {
				Point p2 = it.next();
				long a = (long) (p2.x - p.x) * (p2.x - p.x);
				if (a > min2) break;
				a += (long) (p2.y - p.y) * (p2.y - p.y);
				if (a > min2) continue;
				int dx = p2.x - p.x, dy = p2.y - p.y;
				Point q3 = new Point(p.x + dy, p.y - dx), q4 = new Point(p2.x + dy, p2.y - dx);
				Point r3 = new Point(p.x - dy, p.y + dx), r4 = new Point(p2.x - dy, p2.y + dx);
				if (pts.contains(r3) && pts.contains(r4)) { q3 = r3; q4 = r4; }
				if (pts.contains(q3) && pts.contains(q4)) {
					m2 = p2; m3 = q3; m4 = q4; min2 = a;
				}
			}
			if (m2 == null) {
				System.err.println("ERROR: " + p);
				if (pts.size() < 50) System.err.println(pts);
				System.exit(1);
			}
			sum += min2;
			pts.remove(p); pts.remove(m2); pts.remove(m3); pts.remove(m4);
		}
		System.out.println(sum);
	}
}
